[Algorithm] 面试题之犄角旮旯 第贰章

闲下来后,须要讲最近涉及到的算法所有整理一下,有个indice,方便记忆宫殿的查找php

MIT的算法课,地球上最好: Design and Analysis of Algorithms
html

 

本篇须要从新整理,按照如下归类去理解”思想“,而非”算法细节“。面试

找到解决问题的”思惟突破口“。算法

 

 “贪心算法” 算是 "动态规划" 的前置课程。数组

在数据结构graph中的优化问题也大量涉及到了”Greedy Method"。数据结构

也有五大经常使用算法之说:算法设计之五大经常使用算法设计方法总结ide

1、【分治法】大数据

2、【动态规划法】优化

3、【贪心算法】ui

4、【回溯法】

5、【分支限界法】

 

 

 

Why Puzzles? Solving puzzles will help you sharpen your analytic skills and make you a better problem solver. More over, most of our puzzles can be solved using methods that are either the same or are related to various techniques that we will be using to design algorithms. Click on titles to get to the puzzles.

  1. Puzzles related to recursion and mathematical induction   We start with a set of puzzles that are all related to recursion and mathematical induction. I have chosen interesting but also a bit tough puzzles to get you intrigued, so do not get discouraged if you find them hard. (递归,数学推导)
  2. Puzzles related to probability   Understanding probability theory is necessary for evaluating the behaviour of an algorithm in average (i.e., in finding the expected run time of an algorithm for given probability distribution of inputs).  Probability can be tricky and it often teases our “naïve” common sense, as you might  experience below.
  3. Analytical thinking puzzles   A mix  of various puzzles for developing creative thinking and your analytical ability.

 

 

分治思想


经典算法思想——分治(Divide-and-Conquer)

基本步骤

  • 分解:将原问题分解为若干个规模较小,相互独立,与原问题形式相同的子问题
  • 解决:若子问题规模较小而容易被解决则直接解,不然递归地解各个子问题
  • 合并:将各个子问题的解合并为原问题的解

 

复杂性分析

一个分治法将规模为n的问题分红k个规模为n/m的子问题去解。设分解阈值 [公式] ,且最小子解规模为1的问题消耗一个单位时间。

设将原问题分解为k个子问题以及用merge将K个子问题的解合并为原问题的解需用f(n)个单位时间,用T(n)表示该分治法解规模为|P|=n的问题所需的计算时间: [公式]

 

求解的一些经典问题

  1. 二分搜索
  2. 大整数乘法
  3. Strassen矩阵乘法
  4. 棋盘覆盖
  5. 合并排序
  6. 快速排序
  7. 线性时间选择
  8. 最接近点对问题
  9. 循环赛日程表
  10. 汉诺塔

 

 

 

分治练习


1. Puzzles related to recursion and mathematical induction

We start with a set of puzzles that are all related to recursion and mathematical induction we study in Topic 1. I have chosen interesting but also a bit tough puzzles to get you intrigued, so do not get discouraged if you find them hard.


1.1. The Party Problem

Tom and his wife Mary went to a party where four more couples were present. 五对夫妇,共十人

Not every one knew every everyone else, so people who did not know each other introduced themselves and shook hands. People that knew each other from before did not shake hands.  Later that evening Tom got bored, so he walked around and asked all other guests (including his wife) how many hands they had shaken that evening, and got nine different answers. How many hands did Mary shake? (Hint: you will end up doing recursion on the number of couples…)

Answer:

1. 总共10我的,每一个人不与本身握手,不与配偶握手,不与同一我的握超过一次手,因此每一个人最多握8次手,最少0次;

2. Mr.Smith问其它9我的握了几回手,各人回答不同,因此每一个人的握手次数恰好为0-8次,每种不一样次数有1我的;

3. 有且只有一我的握了8次手,称之为A,即A与其配偶之外的全部人都握了手;【最屡次】

4. 记A的配偶为a,除了A夫妇之外,全部人都至少握了1次手(和A),因此握手0次的确定是a;【最少次】

5. 从10我的中去掉A夫妇,由于A与其他每一个人握了1次手,而a没有与别人握手,因此去掉A夫妇后,其它人的握手次数为1-7(不算Mr.Smith),再去掉他 们各自与A握的那次手不算,则各人的握手次数为0-6,仍是每种不一样次数恰好有1我的;

6. 重复第3-5步4次,直到去掉4对夫妇,最终剩下Mr.&Mrs.Smith,这时Mrs.Smith的握手次数为0,加上4次循环中去掉的4次握手,她总共握 了4次手,与每对夫妇中的某一位各握了一次。

 

 

1.2. The Ten Thieves Problem

Here is an “ancient” small puzzle:

Two thieves have robbed a warehouse and have to split a large pile of various items,  without prices on them. How do they do this in a way that each thief thinks (believes) that he has got at least one half of the value of the whole pile?  

  

You might want to try to solve this puzzle before reading further …

本质:一我的分割,一我的选择 

一个公平的过程每个阶段都是公平的。讲不一样的人分配到不一样的阶段,并具有彻底自主权。

The solution is that one of the two thieves splits the pile into two parts such that he thinks that both parts are of equal value.

The other one then chooses what he thinks is the better part.

It is easy to see that both thieves have reason to believe that they got at least a half (try to explain why).

Now here is the real puzzle for you to solveAssume that ten thieves have robbed the warehouse. How do they split the pile of items so that each thief  thinks that he has got at least one tenth of the total value of the pile? (Hint: This is quite a tough one. It is an example of a nested recursion (a recursion within a recursion)).


 

1.3. Finding the False Coins

(a) We are given 27 coins of the same denomination; we know that one of them is counterfeit and that it is lighter than the others. Find the counterfeit coin by weighing coins on a pan balance only three times. 

(b) We are given 12 coins and one of them is a fake but we do not know if it is heavier or lighter. Can you determine which one is a fake and if it is lighter or heavier by weighing coins on a pan balance three times only? ((a) and (b) are perfect examples of  divide-and-conquer technique). 

(c) We have 9 coins and three of them are heavier than the remaining six. Can you find the heavier coins by weighing coins on a pan balance only four times? (Hint: this is an example of the lower bound estimation of complexity of algorithms, i.e., of the minimal number of steps needed to execute an algorithm for a given input).

Answer:

(a) 9 + 9 + 9【分"三份"】

(b) 4 + 4 + 4

(c)

 

 

1.4. Breaking a chocolate

(a) Assume you are given a block of chocolate consisting of m by n squares. At each move you can break one piece into two (not necessarily equal) pieces (see the picture below). The goal is to get  m × n  separate squares. What is the least number of moves needed to achieve this goal and how should one do it? 

(b) Assume now that you can put several pieces of chocolate on top of each other and break them in a single move. What is now the least number of moves needed to get m × n  separate squares? (Hint: this is an example of estimating complexity of algorithms, i.e., the number of steps needed to execute an algorithm for a given input)

 

 

1.5. The Five Pirates

(a) There are five pirates who have to split 100 bars of gold. They all line up and proceed as follows: 

i) The first pirate in line gets to propose a way to split up the gold (for example: everyone gets 20 bars)

ii) The pirates, including the one who proposed, vote  on whether to accept the proposal. If the proposal is rejected, the prate who made the proposal is killed.

iii) The next pirate in line then makes his proposal, and the 4 pirates vote again. If the vote is tied (2 vs 2) then the proposing pirate is still killed. Only majority can accept a proposal. The process continues until a proposal is accepted or there is only one pirate left. Assume that every pirate :

    • above all wants to live ;
    • given that he will be alive he wants to get as much gold as possible;
    • given maximal possible amount of gold, he wants to see any other
    • pirate killed, just for fun ;
    • each pirate knows his exact position in line;
    • all of the pirates are excellent puzzle solvers.


Question : What proposal should the first pirate make ?

 

(b) Assume now there are 10 pirates splitting 1000 pieces of gold. What should the first pirate propose ?

(An interesting puzzle - recursion seems to be the ONLY way to solve it !!!)


 

1.6. One Way Streets

In Elbonia all cities have a circular one-way highway around the city (in blue on the map below). All streets in the cities are one-way, and they all start and end on the circular highway (see the map).  A block is a part of the city that is not intersected by any street. Design an algorithm that, given a map of a  city, finds a block that can be circumnavigated while respecting all one-way signs. For example, the green block has such property, but the red one does not.  What is the best possible expected (i.e., average) asymptotic run time of such an algorithm?  (Again a recursion, but estimating the expected run time is hard…)

 

Answer:

Walk through the path and mark the areas around - clockwise or anticlockwise.

Or,

the problem became "How to find a smallest cycle in the Directed Graph".

 

 

1.7. 俄罗斯方块

避免那个小方块的漏洞的状况下,如何放积木摆满棋盘。

Tricky: 2^n-1 mod 3 = 0

这个必然也必须的小漏洞分布各个子方格的位置,如上图技巧所示。Divide And Conquer的思想。

 

 

补充:还需再整理...

 01. 找数组中的 duplicated/missing value。

http://stackoverflow.com/questions/3492302/easy-interview-question-got-harder-given-numbers-1-100-find-the-missing-numbe

 02. Party找名人 http://math.stackexchange.com/questions/847371/celebrity-problem-discrete-math 
 03. 博客 - 面试题型总结  http://blog.csdn.net/Hackbuteer1/article/category/899947
 04.   
 05. linkcode 面试题  https://www.lintcode.com/zh-cn/problem/#
 06. 博客 - 常见排序算法总结  http://blog.csdn.net/speedme/article/details/23021467
 07. 基数排序的逐步优化(与快排比较)  http://blog.csdn.net/yutianzuijin/article/details/22876017
 08. 大数据算法面试题  http://blog.csdn.net/v_july_v/article/details/6279498
 09.  linkcode 面试题 (盗版来源)  https://leetcode.com/problemset/algorithms/
相关文章
相关标签/搜索